/**
 * Copyright (C) 2011 Agrosense <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.isobus.type;

import java.util.List;
import nl.cloudfarming.client.isobus.model.CropType;
import nl.cloudfarming.client.isobus.model.CropVariety;
import org.openide.nodes.ChildFactory;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.NbBundle;
import org.openide.util.NbBundle.Messages;

/**
 *
 * @author Gerben Feenstra
 */
@Messages("isobus.project.taskdata.node.name.cropvariety=CropVariety ({0} - {1})")
public class CropTypeChildFactory extends ChildFactory<CropVariety> {

    private static final String CROPVARIETY_NODE_ICON = "";
    private final CropType cropType;

    public CropTypeChildFactory(CropType partField) {
        this.cropType = partField;
    }
    
    
    @Override
    protected boolean createKeys(List<CropVariety> toPopulate) {
        // FIXME: Should not be casted!
        for(Object obj : cropType.getCropVarieties()){
            toPopulate.add((CropVariety) obj);
        }
        return true;
    }

    @Override
    protected Node createNodeForKey(CropVariety cropVariety) {
        String displayName = NbBundle.getMessage(CropTypeChildFactory.class, "isobus.project.taskdata.node.name.cropvariety");
        return new IsobusCommonNode(Children.LEAF, cropVariety, CROPVARIETY_NODE_ICON, displayName);       
    }
}
